#include <stm32f10x.h>
#include "usart.h"
#include "DHT22.h"
#include "delay.h"
#include <stdio.h>
#include <stdlib.h>

void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;	
  
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0000);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;  
  NVIC_Init(&NVIC_InitStructure);
}

int main(void)
{
	float temperature = 0;  	    
	float humidity = 0; 
	SystemInit();
	usart_Configuration();	
	NVIC_Configuration();
	printf("******* Waveshare! ******\r\n");
	delay_ms(1000);
	delay_ms(1000);
	while(DHT22_Init());
	
  DHT22_Read_Data(&temperature,&humidity);

  	while(1)
	{
		delay_ms(1000);
		delay_ms(1000);
        DHT22_Read_Data(&temperature,&humidity);	
		printf("\r\ntemperature =  %.2f\r\n",temperature);
		printf("humidity    =  %.2f\r\n",humidity);
	}
}

