/*
 *  DHT Library for  Digital-output Humidity and Temperature sensors
 *  Works with DHT11, DHT22, AM2302   
 *  Copyright (C) waveshare.net
 *              
 */
#include "mbed.h"
#include "DHT.h"

#define DHTPIN D2 

DHT dht(DHTPIN, DHT22);

int main() {
    
    printf("******DHT22 test program.******\r\n");
    while(1) {
        switch(dht.read())
        {
            case ERROR_NONE:
                printf("\r\nHumidity:    %.1f\r\n",dht.ReadHumidity()); 
                printf("Temperature: %.1f\r\n",dht.ReadTemperature()); 
                break;
            case ERROR_NOT_PRESENT:
                printf("\r\nDHT NOT PRESENT\r\n");break;
            case ERROR_TIMEOUT:
                printf("\r\nDHT TIMEOUT EEROR\r\n");break;
            case ERROR_CHECKSUM:
                printf("\r\nDHT CHECKSUM ERROR\r\n");break;
            default:
                printf("\r\nUNKNOWN EEROR\r\n");break;
        } 
        wait(2);
    }
}
